var assert = require('assert')
var canonicaljson = require('canonicaljson')
var bracery = require('../index')
var ParseTree = bracery.ParseTree

var initJson = { hello: "[yo|hi]",
		 world: ["world", "planet", "kids", "#hello#xxx#hello##hello#zzz"] }

var chomskyJson = {"cyclic":null,"empties":[],"nameByRank":["1","#hello#","4","5","6","8","~hello","~world","3","7","2"],"rankByName":{"#hello#":1,"1":0,"2":10,"3":8,"4":2,"5":3,"6":4,"7":9,"8":5,"~hello":6,"~world":7},"start":"1","stateByName":{"#hello#":{"opts":[{"rhs":[{"name":"3","rank":8,"type":"nonterm"}],"weight":1}],"type":"sym"},"1":{"opts":[{"rhs":[{"name":"~hello","rank":6,"type":"nonterm"},{"name":"8","rank":5,"type":"nonterm"}],"weight":1}],"type":"start"},"2":{"opts":[{"rhs":[{"text":"world","type":"term"}],"weight":2.5E-1},{"rhs":[{"text":"planet","type":"term"}],"weight":2.5E-1},{"rhs":[{"text":"kids","type":"term"}],"weight":2.5E-1},{"rhs":[{"name":"#hello#","rank":1,"type":"nonterm"},{"name":"6","rank":4,"type":"nonterm"}],"weight":2.5E-1}],"type":"alt"},"3":{"opts":[{"rhs":[{"text":"yo","type":"term"}],"weight":5.0E-1},{"rhs":[{"text":"hi","type":"term"}],"weight":5.0E-1}],"type":"alt"},"4":{"opts":[{"rhs":[{"name":"#hello#","rank":1,"type":"nonterm"},{"text":"zzz","type":"term"}],"weight":1}],"type":"elim"},"5":{"opts":[{"rhs":[{"name":"#hello#","rank":1,"type":"nonterm"},{"name":"4","rank":2,"type":"nonterm"}],"weight":1}],"type":"elim"},"6":{"opts":[{"rhs":[{"text":"xxx","type":"term"},{"name":"5","rank":3,"type":"nonterm"}],"weight":1}],"type":"elim"},"7":{"opts":[{"rhs":[{"text":"yo","type":"term"}],"weight":5.0E-1},{"rhs":[{"text":"hi","type":"term"}],"weight":5.0E-1}],"type":"alt"},"8":{"opts":[{"rhs":[{"text":" ","type":"term"},{"name":"~world","rank":7,"type":"nonterm"}],"weight":1}],"type":"elim"},"~hello":{"opts":[{"rhs":[{"name":"7","rank":9,"type":"nonterm"}],"weight":1}],"type":"sym"},"~world":{"opts":[{"rhs":[{"name":"2","rank":10,"type":"nonterm"}],"weight":1}],"type":"sym"}},"stateByRank":[{"opts":[{"rhs":[{"name":"~hello","rank":6,"type":"nonterm"},{"name":"8","rank":5,"type":"nonterm"}],"weight":1}],"type":"start"},{"opts":[{"rhs":[{"name":"3","rank":8,"type":"nonterm"}],"weight":1}],"type":"sym"},{"opts":[{"rhs":[{"name":"#hello#","rank":1,"type":"nonterm"},{"text":"zzz","type":"term"}],"weight":1}],"type":"elim"},{"opts":[{"rhs":[{"name":"#hello#","rank":1,"type":"nonterm"},{"name":"4","rank":2,"type":"nonterm"}],"weight":1}],"type":"elim"},{"opts":[{"rhs":[{"text":"xxx","type":"term"},{"name":"5","rank":3,"type":"nonterm"}],"weight":1}],"type":"elim"},{"opts":[{"rhs":[{"text":" ","type":"term"},{"name":"~world","rank":7,"type":"nonterm"}],"weight":1}],"type":"elim"},{"opts":[{"rhs":[{"name":"7","rank":9,"type":"nonterm"}],"weight":1}],"type":"sym"},{"opts":[{"rhs":[{"name":"2","rank":10,"type":"nonterm"}],"weight":1}],"type":"sym"},{"opts":[{"rhs":[{"text":"yo","type":"term"}],"weight":5.0E-1},{"rhs":[{"text":"hi","type":"term"}],"weight":5.0E-1}],"type":"alt"},{"opts":[{"rhs":[{"text":"yo","type":"term"}],"weight":5.0E-1},{"rhs":[{"text":"hi","type":"term"}],"weight":5.0E-1}],"type":"alt"},{"opts":[{"rhs":[{"text":"world","type":"term"}],"weight":2.5E-1},{"rhs":[{"text":"planet","type":"term"}],"weight":2.5E-1},{"rhs":[{"text":"kids","type":"term"}],"weight":2.5E-1},{"rhs":[{"name":"#hello#","rank":1,"type":"nonterm"},{"name":"6","rank":4,"type":"nonterm"}],"weight":2.5E-1}],"type":"alt"}]}

var cyclicJson = {a:["~b ~c","~b~d"],b:["~e~f"],c:["~f ~g"],d:"",e:["","~a"],f:["[|x]"],g:"x"}
var chomskyCyclicJson = {"stateByName":{"1":{"opts":[{"rhs":[{"name":"~a","rank":9,"type":"nonterm"}],"weight":1}],"type":"start"},"2":{"opts":[{"rhs":[{"name":"~b","rank":1,"type":"nonterm"},{"name":"6","rank":11,"type":"nonterm"}],"weight":5.0E-1},{"rhs":[{"name":"~b","rank":1,"type":"nonterm"},{"name":"~d","rank":12,"type":"nonterm"}],"weight":5.0E-1}],"type":"alt"},"3":{"opts":[{"rhs":[],"weight":5.0E-1},{"rhs":[{"text":"x","type":"term"}],"weight":5.0E-1}],"type":"alt"},"4":{"opts":[{"rhs":[{"text":" ","type":"term"},{"name":"~g","rank":3,"type":"nonterm"}],"weight":1}],"type":"elim"},"5":{"opts":[{"rhs":[],"weight":5.0E-1},{"rhs":[{"name":"~a","rank":9,"type":"nonterm"}],"weight":5.0E-1}],"type":"alt"},"6":{"opts":[{"rhs":[{"text":" ","type":"term"},{"name":"~c","rank":2,"type":"nonterm"}],"weight":1}],"type":"elim"},"~a":{"opts":[{"rhs":[{"name":"2","rank":10,"type":"nonterm"}],"weight":1}],"type":"sym"},"~b":{"opts":[{"rhs":[{"name":"~e","rank":4,"type":"nonterm"},{"name":"~f","rank":5,"type":"nonterm"}],"weight":1}],"type":"sym"},"~c":{"opts":[{"rhs":[{"name":"~f","rank":5,"type":"nonterm"},{"name":"4","rank":6,"type":"nonterm"}],"weight":1}],"type":"sym"},"~d":{"opts":[],"type":"sym"},"~e":{"opts":[{"rhs":[{"name":"5","rank":7,"type":"nonterm"}],"weight":1}],"type":"sym"},"~f":{"opts":[{"rhs":[{"name":"3","rank":8,"type":"nonterm"}],"weight":1}],"type":"sym"},"~g":{"opts":[{"rhs":[{"text":"x","type":"term"}],"weight":1}],"type":"sym"}},"cyclic":null,"empties":["3","5","~b","~e","~f"],"rankByName":{"1":0,"2":10,"3":8,"4":6,"5":7,"6":11,"~a":9,"~b":1,"~c":2,"~d":12,"~e":4,"~f":5,"~g":3},"stateByRank":[{"opts":[{"rhs":[{"name":"~a","rank":9,"type":"nonterm"}],"weight":1}],"type":"start"},{"opts":[{"rhs":[{"name":"~e","rank":4,"type":"nonterm"},{"name":"~f","rank":5,"type":"nonterm"}],"weight":1}],"type":"sym"},{"opts":[{"rhs":[{"name":"~f","rank":5,"type":"nonterm"},{"name":"4","rank":6,"type":"nonterm"}],"weight":1}],"type":"sym"},{"opts":[{"rhs":[{"text":"x","type":"term"}],"weight":1}],"type":"sym"},{"opts":[{"rhs":[{"name":"5","rank":7,"type":"nonterm"}],"weight":1}],"type":"sym"},{"opts":[{"rhs":[{"name":"3","rank":8,"type":"nonterm"}],"weight":1}],"type":"sym"},{"opts":[{"rhs":[{"text":" ","type":"term"},{"name":"~g","rank":3,"type":"nonterm"}],"weight":1}],"type":"elim"},{"opts":[{"rhs":[],"weight":5.0E-1},{"rhs":[{"name":"~a","rank":9,"type":"nonterm"}],"weight":5.0E-1}],"type":"alt"},{"opts":[{"rhs":[],"weight":5.0E-1},{"rhs":[{"text":"x","type":"term"}],"weight":5.0E-1}],"type":"alt"},{"opts":[{"rhs":[{"name":"2","rank":10,"type":"nonterm"}],"weight":1}],"type":"sym"},{"opts":[{"rhs":[{"name":"~b","rank":1,"type":"nonterm"},{"name":"6","rank":11,"type":"nonterm"}],"weight":5.0E-1},{"rhs":[{"name":"~b","rank":1,"type":"nonterm"},{"name":"~d","rank":12,"type":"nonterm"}],"weight":5.0E-1}],"type":"alt"},{"opts":[{"rhs":[{"text":" ","type":"term"},{"name":"~c","rank":2,"type":"nonterm"}],"weight":1}],"type":"elim"},{"opts":[],"type":"sym"}],"nameByRank":["1","~b","~c","~g","~e","~f","4","5","3","~a","2","6","~d"],"start":"1"}

var topoJson = {a:["~b ~c","~b ~d"],b:["~e ~f"],c:["~f ~g"],d:"",e:["","~a"],f:["[|x]"],g:"x"}
var chomskyTopoJson = {"stateByName":{"1":{"opts":[{"rhs":[{"name":"~a","rank":13,"type":"nonterm"}],"weight":1}],"type":"start"},"2":{"opts":[{"rhs":[{"name":"~b","rank":3,"type":"nonterm"},{"name":"7","rank":1,"type":"nonterm"}],"weight":5.0E-1},{"rhs":[{"name":"~b","rank":3,"type":"nonterm"},{"name":"8","rank":2,"type":"nonterm"}],"weight":5.0E-1}],"type":"alt"},"3":{"opts":[{"rhs":[],"weight":5.0E-1},{"rhs":[{"text":"x","type":"term"}],"weight":5.0E-1}],"type":"alt"},"4":{"opts":[{"rhs":[{"text":" ","type":"term"},{"name":"~g","rank":8,"type":"nonterm"}],"weight":1}],"type":"elim"},"5":{"opts":[{"rhs":[],"weight":5.0E-1},{"rhs":[{"name":"~a","rank":13,"type":"nonterm"}],"weight":5.0E-1}],"type":"alt"},"6":{"opts":[{"rhs":[{"text":" ","type":"term"},{"name":"~f","rank":7,"type":"nonterm"}],"weight":1}],"type":"elim"},"7":{"opts":[{"rhs":[{"text":" ","type":"term"},{"name":"~c","rank":4,"type":"nonterm"}],"weight":1}],"type":"elim"},"8":{"opts":[{"rhs":[{"text":" ","type":"term"},{"name":"~d","rank":5,"type":"nonterm"}],"weight":1}],"type":"elim"},"~a":{"opts":[{"rhs":[{"name":"2","rank":14,"type":"nonterm"}],"weight":1}],"type":"sym"},"~b":{"opts":[{"rhs":[{"name":"~e","rank":6,"type":"nonterm"},{"name":"6","rank":9,"type":"nonterm"}],"weight":1}],"type":"sym"},"~c":{"opts":[{"rhs":[{"name":"~f","rank":7,"type":"nonterm"},{"name":"4","rank":10,"type":"nonterm"}],"weight":1}],"type":"sym"},"~d":{"opts":[],"type":"sym"},"~e":{"opts":[{"rhs":[{"name":"5","rank":11,"type":"nonterm"}],"weight":1}],"type":"sym"},"~f":{"opts":[{"rhs":[{"name":"3","rank":12,"type":"nonterm"}],"weight":1}],"type":"sym"},"~g":{"opts":[{"rhs":[{"text":"x","type":"term"}],"weight":1}],"type":"sym"}},"cyclic":null,"empties":["3","5","~e","~f"],"rankByName":{"1":0,"2":14,"3":12,"4":10,"5":11,"6":9,"7":1,"8":2,"~a":13,"~b":3,"~c":4,"~d":5,"~e":6,"~f":7,"~g":8},"stateByRank":[{"opts":[{"rhs":[{"name":"~a","rank":13,"type":"nonterm"}],"weight":1}],"type":"start"},{"opts":[{"rhs":[{"text":" ","type":"term"},{"name":"~c","rank":4,"type":"nonterm"}],"weight":1}],"type":"elim"},{"opts":[{"rhs":[{"text":" ","type":"term"},{"name":"~d","rank":5,"type":"nonterm"}],"weight":1}],"type":"elim"},{"opts":[{"rhs":[{"name":"~e","rank":6,"type":"nonterm"},{"name":"6","rank":9,"type":"nonterm"}],"weight":1}],"type":"sym"},{"opts":[{"rhs":[{"name":"~f","rank":7,"type":"nonterm"},{"name":"4","rank":10,"type":"nonterm"}],"weight":1}],"type":"sym"},{"opts":[],"type":"sym"},{"opts":[{"rhs":[{"name":"5","rank":11,"type":"nonterm"}],"weight":1}],"type":"sym"},{"opts":[{"rhs":[{"name":"3","rank":12,"type":"nonterm"}],"weight":1}],"type":"sym"},{"opts":[{"rhs":[{"text":"x","type":"term"}],"weight":1}],"type":"sym"},{"opts":[{"rhs":[{"text":" ","type":"term"},{"name":"~f","rank":7,"type":"nonterm"}],"weight":1}],"type":"elim"},{"opts":[{"rhs":[{"text":" ","type":"term"},{"name":"~g","rank":8,"type":"nonterm"}],"weight":1}],"type":"elim"},{"opts":[{"rhs":[],"weight":5.0E-1},{"rhs":[{"name":"~a","rank":13,"type":"nonterm"}],"weight":5.0E-1}],"type":"alt"},{"opts":[{"rhs":[],"weight":5.0E-1},{"rhs":[{"text":"x","type":"term"}],"weight":5.0E-1}],"type":"alt"},{"opts":[{"rhs":[{"name":"2","rank":14,"type":"nonterm"}],"weight":1}],"type":"sym"},{"opts":[{"rhs":[{"name":"~b","rank":3,"type":"nonterm"},{"name":"7","rank":1,"type":"nonterm"}],"weight":5.0E-1},{"rhs":[{"name":"~b","rank":3,"type":"nonterm"},{"name":"8","rank":2,"type":"nonterm"}],"weight":5.0E-1}],"type":"alt"}],"nameByRank":["1","7","8","~b","~c","~d","~e","~f","~g","6","4","5","3","~a","2"],"start":"1"}

var b = new bracery.Bracery (initJson)
describe('Chomsky normal form', function() {
  it('should convert a test grammar into Chomsky normal form', function (done) {
    bracery.Chomsky.makeGrammar ({ get: b._getSymbol.bind(b),
                                   normal: true,
                                   root: '~hello ~world' })
      .then (function (json) {
        assert.equal (canonicaljson.stringify(json), canonicaljson.stringify(chomskyJson))
        done()
      }).catch (done)
        })

  it('should find a null cycle', function (done) {
    var b2 = new bracery.Bracery (cyclicJson)
    bracery.Chomsky.makeGrammar ({ get: b2._getSymbol.bind(b2),
                                   normal: true,
                                   root: '~a' })
      .then (function (json2) {
        assert.equal (canonicaljson.stringify(json2), canonicaljson.stringify(chomskyCyclicJson))
        done()
      }).catch (done)
        })

  it('should toposort', function (done) {
    var b3 = new bracery.Bracery (topoJson)
    bracery.Chomsky.makeGrammar ({ get: b3._getSymbol.bind(b3),
                                   normal: true,
                                   root: '~a' })
      .then (function (json3) {
        assert.equal (canonicaljson.stringify(json3), canonicaljson.stringify(chomskyTopoJson))
        done()
      }).catch (done)
        })

})
